unit Ulcp100;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs,LCP100, StdCtrls,cpdrv, ExtCtrls, ComCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    lblPort: TLabel;
    CheckBox1: TCheckBox;
    Button2: TButton;
    Edit1: TEdit;
    Button3: TButton;
    Edit2: TEdit;
    Image1: TImage;
    Label1: TLabel;
    Button4: TButton;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    ComboBox1: TComboBox;
    Button5: TButton;
    ProgressBar1: TProgressBar;
    Button6: TButton;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure ComboBox1Change(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure update_progress(position:integer);  stdcall;
    procedure Button6Click(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;
  LCP:TLCP100;

implementation

{$R *.dfm}

procedure TForm1.Button1Click(Sender: TObject);
begin
  if lcp.Connect then
  begin
     form1.Cursor:=crHourGlass;
      label5.Caption:='Activate LCP100 Test Image';
      Form1.refresh;
    lcp.ShowTestImage;
    sleep(2000);
     label5.Caption:=' Activate Page 1';
     Form1.refresh;
    edit1.text:='1';
    Button2Click(self);
     form1.Cursor:=crdefault;
  end;
end;

procedure TForm1.Button2Click(Sender: TObject);
var page:integer;
  bmp:TBitmap;
begin
     if lcp.Connect then
  begin
    bmp:=TBitmap.Create;
     form1.Cursor:=crHourGlass;
    try

    page:=strtoint(edit1.text);

     label5.Caption:='Select Page on LCP100..';
     Form1.refresh;
    lcp.ShowPageNo(page);
    bmp.Height:=128;
    bmp.Width:=128;
    bmp.PixelFormat:=pf24bit;
     label5.Caption:='Download Bitmap from LCP100..';
     Form1.refresh;
    lcp.DownloadImage(bmp,page);
    image1.Picture.Bitmap:=bmp;
     edit1.Text:=inttostr(lcp.PageShowing);
     checkbox1.Checked:=lcp.BacklightOn;

    finally
      bmp.Free;
      form1.Cursor:=crDefault;
       label5.Caption:='Action finished';
       Progressbar1.Position:=0;
       Form1.refresh;
    end;
  end;
end;

procedure TForm1.Button3Click(Sender: TObject);
var page:integer;
  bmp:TBitmap;

begin
       if lcp.Connect then
  begin
   bmp:=TBitmap.Create;
    try
    page:=strtoint(edit1.text);
    form1.Cursor:=crHourglass;
     label5.Caption:='Load File';
     Form1.refresh;
    bmp.LoadFromFile(edit2.Text);
    bmp.Height:=128;
    bmp.Width:=128;
    bmp.PixelFormat:=pf24bit;
    bmp.Canvas.StretchDraw(bmp.Canvas.ClipRect,bmp);
    bmp.Canvas.StretchDraw(image1.Canvas.ClipRect,bmp);
    image1.Picture.Bitmap:=bmp;
     label5.Caption:='Uploading to LCP';
     Form1.refresh;
    lcp.UploadImage(bmp,page);
     label5.Caption:='Upload finished, Activating Page..';
     Form1.refresh;
    lcp.ShowPageNo(page);
     edit1.Text:=inttostr(lcp.PageShowing);
     checkbox1.Checked:=lcp.BacklightOn;
    finally
    bmp.Free;
    form1.Cursor:=crDefault;
      label5.Caption:='Action finished';
      Progressbar1.Position:=0;
      Form1.refresh;
    end;
  end;
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
label5.Caption:='Get Version';
Form1.refresh;
 Label1.Caption:='Version: '+lcp.FirmwareVersion;
 label5.Caption:='Get Version finished';
 Form1.refresh;
end;

procedure TForm1.Button5Click(Sender: TObject);
begin
  if lcp.Connect then
  begin
    lcp.ClearDisplay;
  end;
end;

procedure TForm1.Button6Click(Sender: TObject);
begin
  button2click(self);
  image1.Picture.bitmap.SaveToFile(edit2.Text);
end;

procedure TForm1.CheckBox1Click(Sender: TObject);
begin
  if lcp.Connect then
  begin
            lcp.BacklightOn:=checkbox1.Checked;
            checkbox1.Checked:=lcp.BacklightOn;
  end;
end;

procedure TForm1.ComboBox1Change(Sender: TObject);
var portname:string;
begin
     portname:=trim(combobox1.text);
     lcp.setComPortByName(portname);
     lblport.Caption:='Port '+ inttostr(ord(lcp.CommPortNo));
end;

procedure TForm1.FormCreate(Sender: TObject);
var portlist:TStrings;
begin
  lcp:=TLCP100.Create(self);
  lcp.Progress:=update_progress;
  portlist:=lcp.Find_LCP100_ComPort;
  progressbar1.Max:=64;
  if portlist.Count>0 then
  begin
        combobox1.Items:=portlist;
        combobox1.ItemIndex:=0;
        ComboBox1Change(self);
        checkbox1.Checked:=lcp.BacklightOn;
  end
  else
  begin
        lblport.Caption:='No CP2102!';
  end;
  image1.Picture.Bitmap:=lcp.PageImage;//default blank page
end;
procedure TForm1. update_progress(position:integer);  stdcall;
begin
  Progressbar1.Position:=position;
  Progressbar1.Repaint;
end;

end.
